-- CS422 X04 Homework 4
-- C.S.

--
-- 1.
--
select firstname, lastname, region from members where region = 'VA';

--
-- 2.
--
select *  from tracks where mp3 = 0;

--
-- 3.
--
select titleid, count(tracknum) from tracks group by titleid;

--
-- 4.
--
select leadsource, count(artistid) from artists group by leadsource;

--
-- 5.
-- (a) another way is to do "select min(lastname)"
-- (b) it's important to know LIMIT
--
select lastname from members order by lastname asc limit 1;

--
-- 6. there're a number of ways to do joins:
--	from t1, t2 where t1.x = t2.x
--	t1 join t2 on t1.x = t2.x
--	t1 natural join t2
--
select tracktitle
	from titles t, tracks x
	where t.titleid = x.titleid and t.genre = 'alternative';

--
-- 7.
--
select max(x.lengthseconds)
	from titles t, tracks x
	where t.titleid = x.titleid and t.genre = 'metal' and x.realaud = 1;

--
-- 8.
-- (a) it's likely to be more efficient to do "select max(x.lengthseconds)"
-- (b) usage of ALL
--
select tracktitle, lengthseconds
	from tracks
	where lengthseconds > ALL (select x.lengthseconds
		from titles t, tracks x
		where t.titleid = x.titleid and t.genre = 'metal');

--
-- 9.
--
select t.title, s.studioname from titles t natural join studios s;

--
-- 10.
--
select studioname, substring(contact for position(' ' in contact)) from studios;

--
-- 11.
-- (a) another interpretation is to consider (city,region) together, which is
--     fine.
-- (b) intersect
--
(select a.city from artists a join members m on a.city = m.city)
union
(select a.region from artists a join members m on a.region = m.region);

--
-- 12. all genres listed, and 0 for those which do not have any tracks
--     recorded.
--
(select t.genre, sum(x.lengthseconds)/60
	from titles t, tracks x
	where t.titleid = x.titleid group by t.genre)
union
(select g.genre, 0
	from titles t right join genre g on t.genre = g.genre
	where t.titleid is null);

--
-- 13.
--
select artistname from artists
	where leadsource='Email'
	and artistid NOT IN (select artistid from titles);

--
-- 14.
--
select artistname, count(memberid)
	from artists natural join xrefartistsmembers
	group by artistname;

--
-- 15.
--
select s1.firstname || ' ' || s1.lastname
	from salespeople s1, salespeople s2
	where s1.supervisor = s2.salesid and s2.supervisor is null;

--
-- 16. what if the salesperson does not have a supervisor?
--
select	m.firstname || ' ' || m.lastname as "Member",
	s1.firstname || ' ' || s1.lastname as "1st Contact",
	s2.firstname || ' ' || s2.lastname as "2nd Contact"
	from members m, salespeople s1, salespeople s2
	where m.salesid = s1.salesid and s1.supervisor = s2.salesid;

--
-- 17.
--
select studioname, substring(contact for position(' ' in contact)) from studios;

--
-- 18.
--
select	a.artistname as "Name",
	extract(year from age(a.entrydate, m.birthday)) as "Age"
	from artists a natural join xrefartistsmembers natural join members m
	where respparty = 1;

--
-- 19.
--
select initcap(genre) from genre;

--
-- 20.
--
select a.artistname from artists a
	where not exists (select 1 from titles t where t.artistid = a.artistid);

--
-- 21.
--
select g.genre from genre g
	where not exists (select 1 from titles t where t.genre = g.genre);

--
-- 22.
--
select t.title, count(x.tracknum), sum(x.lengthseconds)/60
	from titles t natural join tracks x
	group by t.title;

--
-- 23.
--
update members set salesid =	(select salesid from salespeople where
				firstname = 'Lisa' and lastname = 'Williams')
	where salesid =	(select salesid from salespeople where
			firstname = 'Bob' and lastname = 'Bentley')
	and gender = 'F';

--
-- 24.
--
insert into artists (artistid, artistname, city, region, country, entrydate)
	(select 13, 'Doug and Terry', city, region, country, current_date
		from members where firstname = 'Doug' and lastname = 'Finney');

--
-- 25.
-- (a) no need for type cast
-- (b) cast( expression as type )
--
update artists set webaddress = 'www.lyricmusic.com/' || artistid
	where webaddress is null;

